//+------------------------------------------------------------------+
//|                                               Moving Average.mq4 |
//|                   Copyright 2005-2014, MetaQuotes Software Corp. |
//|                                              http://www.mql4.com |
//+------------------------------------------------------------------+
#property copyright   "2007-2016, Janusz O"
#property link        "http://www.forexfactory.com/januszo"
#property description ""

 
 // classes 
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
// abstract signal class
class TrendSignal
  {
  
public:
                     TrendSignal();
                    ~TrendSignal();



                    virtual int GetTrendSide(){ Print("call to TrendSignal::GetTrendSide");  return 0;}
                    virtual int ClosePosition(){return true;}
                    virtual double GetRisk(){return 0;}


  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
TrendSignal::TrendSignal()
  {
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
TrendSignal::~TrendSignal()
  {
  }
//+------------------------------------------------------------------+



class PriceGetter
{
protected:
   string   _symbol;
   ENUM_TIMEFRAMES _period;
public: //  fields
               string   GetSymbol()                {return this._symbol;}
               ENUM_TIMEFRAMES    
                        GetPeriod()                {return this._period;}
string TF2Str()
  {
  int period = (int)this._period;
   switch(period)
     {
      case PERIOD_M1: return("M1");
      case PERIOD_M5: return("M5");
      case PERIOD_M15: return("M15");
      case PERIOD_M30: return("M30");
      case PERIOD_H1: return("H1");
      case PERIOD_H4: return("H4");
      case PERIOD_D1: return("D1");
      case PERIOD_W1: return("W1");
      case PERIOD_MN1: return("MN");
     }
   return("unknown");
  }                        
                        
                        
public:           // functionality             
               datetime TimeP(int shift)           {return iTime(_symbol, _period, shift);}
               double   CloseP(int shift)          {return iClose(_symbol,_period, shift);}
               double   OpenP(int shift)           {return iOpen(_symbol, _period, shift);}
               double   HighP(int shift)           {return iHigh(_symbol, _period, shift);}
               double   LowP(int shift)            {return iLow(_symbol, _period, shift);}
               long   VolumeP(int shift)          {return iVolume(_symbol,_period, shift);}
               int   HighestPIndex(int priceType,int nbars,int startBar)        {  return iHighest(_symbol, _period, priceType,nbars,startBar); }               
               int   HighestPIndex(int nbars)                                   {  return HighestPIndex(MODE_HIGH,nbars,0);       }
               int   HighestPIndex(int nbars,int startBar)                      {  return HighestPIndex(MODE_HIGH,nbars,startBar);}

               
 /* priceType:
0 Open price
1 Low price
2 High price
3 Close price
4 volume
 */
  

               int   LowestPIndex(int priceType,int nbars,int startBar)         {  return  iLowest(_symbol, _period, priceType,nbars,startBar);  }
               int   LowestPIndex(int nbars)                                    {  return LowestPIndex(MODE_LOW,nbars,0);         }
               int   LowestPIndex(int nbars,int startBar)                       {  return LowestPIndex(MODE_LOW,nbars,startBar);  }

               double HighestPrice(int nbars,int startBar) {return HighP(HighestPIndex(nbars,startBar));} 
               double HighestPrice(int nbars) {return HighestPrice(nbars,0);} 
               double LowestPrice(int nbars,int startBar) {return LowP(LowestPIndex(nbars,startBar));} 
               double LowestPrice(int nbars) {return LowestPrice(nbars,0);} 


               double Get_MI(int mode){return MarketInfo(_symbol,mode);}
               double Get_Bid(){return Get_MI(MODE_BID);}
               double Get_Ask(){return Get_MI(MODE_ASK);}
               double Get_Point(){return Get_MI(MODE_POINT);}
               double Get_StopLevel(){return Get_MI(MODE_STOPLEVEL);}
               
               datetime Get_Time(){return (datetime)Get_MI(MODE_TIME);}

               double Get_SpreadInPoints()
               {
                  //return    Get_MI(MODE_SPREAD);
                  return GetSpreadInPriceFraction()/this.Get_Point();   
               }
               double Get_MinLotSize(){return Get_MI(MODE_MINLOT);}



int GetDigits()
{ 
/*
   double Bid1 =MarketInfo(_symbol,MODE_BID);   
   double Point1 =MarketInfo(_symbol,MODE_POINT);
    
   double pip_value = MathPow(10.0, MathFloor(MathLog(Bid1 / 2.0) / MathLog(10.0)) - 3);
   int pip_digits =(int) MathRound(MathLog(pip_value / Point1) / MathLog(10.0));
   return pip_digits;
   */
return(int)Get_MI(MODE_DIGITS);

}


double GetSpreadInPriceFraction()
{ 
   //double point= Get_Point();
   //double spreadInPoints=Get_SpreadInPoints();
   //return (spreadInPoints*point);
    return this.Get_Ask() - this.Get_Bid();
}

double GetPipPriceFraction()
{/*
   double Bid1 =MarketInfo(_symbol,MODE_BID);   
   double Point1 =MarketInfo(_symbol,MODE_POINT);
    
   double pip_value = MathPow(10.0, MathFloor(MathLog(Bid1 / 2.0) / MathLog(10.0)) - 3);
   //int pip_digits =(int) MathRound(MathLog(pip_value / Point1) / MathLog(10.0));
   return pip_value ;
*/
   
   double point = Get_Point();
   int digits=GetDigits();
   
   if((digits==3) || (digits==5))
     {
      point*=10;
     }
     
      
   return point;
   
}

double GetPipPLNValue()
{

   string symbol = this._symbol;

/*
   double pipPriceFraction = GetPipPriceFraction();
   double tickvalue = MarketInfo(symbol,MODE_TICKVALUE);
   double ticksize  = MarketInfo(symbol,MODE_TICKSIZE);   
   double PipValue=(((tickvalue*pipPriceFraction)/ticksize));   
   return NormalizeDouble(PipValue,5);
   */
   
   int digits=GetDigits();
   //double point=MarketInfo(symbol,MODE_POINT);
   double multiplier = ((digits==3) || (digits==5))?10:1;   
   double tickvalue = MarketInfo(symbol,MODE_TICKVALUE)*multiplier ;      
   return NormalizeDouble(tickvalue ,12);
}
   
double GetNormalized(double d) { 
double d1=d;
double d2 = NormalizeDouble(d1,  GetDigits());
return (d2);
}


double GetCurrentQuoteForOpen(int side)
 {
          double open;
         if(side<0) // short
         {
          open= Get_MI(MODE_BID);   
         }
         else // long
         {
          open=Get_MI(MODE_ASK);      
         }
      return open;
 }


 double  GetCurrentQuoteForClose(int side)
 {
         double open;
         if(side>0) // long
         {
          open= Get_MI(MODE_BID);   
         }
         else // long
         {
          open=Get_MI(MODE_ASK);      
         }
      return open;
 }
 
 int PipsToPointFactor()
  {

   int point=1;
   int digits=this.GetDigits();

   if(digits==5 || digits==3) //Check whether it's a 5 digit broker (3 digits for Yen)
   point=10; //1 pip to 10 point if 5 digit
   
   else if(digits==4 || digits==2)
   point=1; //1 pip to 1 point if 4 digit

   return(point);

  }
   // PriceGetter(string symbol);
    PriceGetter(string symbol,ENUM_TIMEFRAMES period );
    ~PriceGetter();
};
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
/*
PriceGetter::PriceGetter(string symbol)
  {   
   _symbol = symbol;
   _period = PERIOD_CURRENT; 
  
  }
  */
PriceGetter::PriceGetter(string symbol,ENUM_TIMEFRAMES period     )
  {   
   _symbol = symbol;
   _period = period;  
  }
  
  
  
  

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
PriceGetter::~PriceGetter()
  {
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                  MACD Sample.mq4 |
//|                   Copyright 2005-2014, MetaQuotes Software Corp. |
//|                                              http://www.mql4.com |
//+------------------------------------------------------------------+
  



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
 class TimeBasedFilter : public TrendSignal
  {
private:
//
TrendSignal * _reva;
 PriceGetter* _pg;
 
 

bool _days[6]; //sunday=0,monday=1..
bool _hours[24]; // 0 ..24
public:
//   
//
TimeBasedFilter(
 
                        
                        string symbol,
                        ENUM_TIMEFRAMES period,
                        // n steps to make avg indicating trend
TrendSignal * reva,
 bool takeSunday, 
 bool takeMonday,
 bool takeWendesday,
 bool takeTuesday,
 bool takeThursday, 
 bool takeFriday,

 bool take00, 
 bool take01,
 bool take02,
 bool take03,
 bool take04, 
 bool take05,
 bool take06, 
 bool take07,
 bool take08,
 bool take09,
 bool take10, 
 bool take11,
 bool take12, 
 bool take13,
 bool take14,
 bool take15,
 bool take16, 
 bool take17,
 bool take18, 
 bool take19,
 bool take20,
 bool take21,
 bool take22, 
 bool take23 
            
                       
                                          
                     )  
{

_pg = new PriceGetter(symbol,period);
      _reva = reva;
      
 
 


  _days[0]=takeSunday; 
  _days[1]=takeMonday;
  _days[2]=takeWendesday;
  _days[3]=takeTuesday;
  _days[4]=takeThursday;
  _days[5]=takeFriday;

  _hours[00]=take00;
  _hours[01]=take01;
  _hours[02]=take02;
  _hours[03]=take03;
  _hours[04]=take04; 
  _hours[05]=take05;
  _hours[06]=take06;
  _hours[07]=take07;
  _hours[08]=take08;
  _hours[09]=take09;
  _hours[10]=take10;
  _hours[11]=take11;
  _hours[12]=take12;
  _hours[13]=take13;
  _hours[14]=take14;
  _hours[15]=take15;
  _hours[16]=take16;
  _hours[17]=take17;
  _hours[18]=take18;
  _hours[19]=take19;
  _hours[20]=take20;
  _hours[21]=take21;
  _hours[22]=take22;
  _hours[23]=take23;     
      
      }
      

 
              ~TimeBasedFilter()
  {
  
   if (_pg!=NULL)
   {
      delete _pg;
   }
   

   
  }

     

      virtual int GetTrendSide()
      {      
          int side=0;
          datetime dt = this._pg.TimeP(0);

          MqlDateTime str1;
          TimeToStruct(dt,str1); 

          int day =  str1.day_of_week;
          int hour =   str1.hour;
          //if(_sup.Supervise())
         // {         
         
         Print(hour, ",",day);
            if(this._hours[hour]== true &&  this._days[day] == true)
            {                                 
            side= this._reva.GetTrendSide(); 
           }         
          return side;
      } 
                     
      virtual int ClosePosition()
      {      
         // when another alog - do not close position?
          //if(_sup.Supervise())
          //{
            return _reva.ClosePosition();                     
          //}
          //return 0;
      }//
                
      virtual double GetRisk()
      {
         return _reva.GetRisk();
      }
 

    };



 
//+------------------------------------------------------------------+
class your_implementation_of_TrendSignal_GetSide_method : public TrendSignal
{

// put open trade logic here
// open trade +1 buy, -1 sell  , 0 nothing
      virtual int GetTrendSide()
      {      
          int side=1;
          
          return side;
      } 
                     
                     // close  or ignore it
      virtual int ClosePosition()
      {      

            return -1;                     
          
      }//
                
                // get risk -- ie 23 pips = 0.0023 or ignore it
      virtual double GetRisk()
      {
         return 0.0023;
      }
 

};
 
 
 

//

TrendSignal* _signal;
TrendSignal* _signal2;




//
//| OnTick function                                                  |
//+------------------------------------------------------------------+
void OnTick()
  {
  //Print("tick");
//--- check for history and trading
   if(IsTradeAllowed()==false)
      return;
      
      
      // call 
      //_signal2.GetTrendSide()
      // to open trades..
      
//
//| Check for open order conditions                                  |
//| Check for close order conditions                                 |
//

//
//---
  }
//  
//+------------------------------------------------------------------+
//
//
//
  
 
 
 

input bool  _takeSunday= true; 
 input bool  _takeMonday= true;
 input bool  _takeWendesday= true;
 input bool  _takeTuesday= true;
 input bool  _takeThursday= true; 
 input bool  _takeFriday= true;

 input bool  _take00= true; 
 input bool  _take01= true;
 input bool  _take02= true;
 input bool  _take03= true;
 input bool  _take04= true; 
 input bool  _take05= true;
 input bool  _take06= true; 
 input bool  _take07= true;
 input bool  _take08= true;
 input bool  _take09= true;
 input bool  _take10= true; 
 input bool  _take11= true;
 input bool  _take12= true; 
 input bool  _take13= true;
 input bool  _take14= true;
 input bool  _take15= true;
 input bool  _take16= true; 
 input bool  _take17= true;
 input bool  _take18= true; 
 input bool  _take19= true;
 input bool  _take20= true;
 input bool  _take21= true;
 input bool  _take22= true; 
 input bool  _take23 =true;
     
//
//

//
input int MAGICMA  =16063001;
//
//
//
void OnInit()
{

      string _symbol = Symbol();
      ENUM_TIMEFRAMES _period = (ENUM_TIMEFRAMES)Period();
     
      _signal = new  your_implementation_of_TrendSignal_GetSide_method(); //EngulfingCandleSignalNNFilter001(_symbol,_period,_signal,_x1,_x2,_x3,_x4,_p2,_pass);
      _signal2 = new TimeBasedFilter(_symbol,_period,_signal2,
      
 _takeSunday, 
  _takeMonday,
  _takeWendesday,
  _takeTuesday,
  _takeThursday, 
  _takeFriday,

  _take00, 
  _take01,
  _take02,
  _take03,
  _take04, 
  _take05,
  _take06, 
  _take07,
  _take08,
  _take09,
  _take10, 
  _take11,
  _take12, 
  _take13,
  _take14,
  _take15,
  _take16, 
  _take17,
  _take18, 
  _take19,
  _take20,
  _take21,
  _take22, 
  _take23 
  );
           
      
       
}

void OnDeinit(const int reason)
{
   
   delete _signal;
   delete _signal2;
   
}
 